<?php
/**
 * @package	HikaShop for Joomla!
 * @version	3.0.1
 * @author	hikashop.com
 * @copyright	(C) 2010-2017 HIKARI SOFTWARE. All rights reserved.
 * @license	GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

//ini_set('date.timezone','Asia/Shanghai');
//error_reporting(E_ERROR);
require_once __DIR__ . "/lib/wechatpay.api.php";
require_once __DIR__ . "/lib/wechatpay.notify.php";
require_once __DIR__ . '/log.php';

//初始化日志
$logHandler= new CLogFileHandler("../logs/".date('Y-m-d').'.log');
$log = Log::Init($logHandler, 15);

class PayNotifyCallBack extends WxPayNotify
{
		//查询订单
	public function Queryorder($transaction_id)
	{
		$input = new WxPayOrderQuery();
		$input->SetTransaction_id($transaction_id);
		$result = WxPayApi::orderQuery($input);
		//Log::DEBUG("query:" . json_encode($result));
		if(array_key_exists("return_code", $result)
			&& array_key_exists("result_code", $result)
			&& $result["return_code"] == "SUCCESS"
			&& $result["result_code"] == "SUCCESS")
		{
			return true;
		}
		return false;
	}
	
		//TODO 重写回调处理函数方法，成功的时候返回true，失败返回false
	public function NotifyProcess($data, &$msg)
	{
		//Log::DEBUG("call back:" . json_encode($data));
		if($this->payment_params->debug) {
			$this->writeToLog(print_r($data, true) . "\r\n\r\n");
		}
		
		if(!$this->payment_params->notification) {
			$msg = "未开启回调通知";
			return false;
		}
	/*
		$notfiyOutput = array();
		$filter = JFilterInput::getInstance();
		foreach($_REQUEST as $key => $value) {
			$key = $filter->clean($key);
			if(preg_match('#^[0-9a-z_-\$]{1,30}$#i', $key) && !preg_match('#^cmd$#i', $key)) {
				$value = JRequest::getString($key);
				$notfiyOutput[$key] = $value;
			}
		}
	*/
		$app = JFactory::getApplication();

		//if payment connection failed 微信支付通信失败
		if($data['return_code'] == 'FAIL') {
			$app->enqueueMessage('Notification refused because the payment connection failed');
			$msg = "微信支付通信失败";
			return false;
		}
		
		//判断回调的通知数据是否含有微信支付订单号
		if(!array_key_exists("transaction_id", $data)){
			$msg = "微信支付订单号缺失";
			return false;
		}
		
		//查询订单，判断订单真实性
		if(!$this->Queryorder($data["transaction_id"])){
			$msg = "订单查询失败";
			return false;
		}
		
        //获取商户订单信息
		$order_id = (int)@$data['out_trade_no'];
		$dbOrder = $this->getOrder($order_id);
		$this->loadPaymentParams($dbOrder);
		$this->loadOrderData($dbOrder);

		if(empty($dbOrder)){
			$this->writeToLog("Could not load any order for your notification ".$order_id."\r\n\r\n");
			$msg = "订单查询失败";
			return false;
		}
		
		if($this->payment_params->debug) {
			$this->writeToLog(print_r($dbOrder, true) . "\r\n\r\n");
		}
		
		$order_url = HIKASHOP_LIVE.'index.php?option=com_hikashop&ctrl=order&task=show&cid='.$order_id;
		$order_text = "\r\n\r\n".JText::sprintf('NOTIFICATION_OF_ORDER_ON_WEBSITE', $dbOrder->order_number, HIKASHOP_LIVE);
		$order_text .= "\r\n".str_replace('<br/>', "\r\n", JText::sprintf('ACCESS_ORDER_WITH_LINK', $order_url));

		if($data['return_code'] == 'SUCCESS' && $data['result_code'] == 'SUCCESS' && $data['total_fee'] == round($dbOrder->order_full_price * 100)) {

			//if payment is OK 支付成功
			
			$history = new stdClass();
			$email = new stdClass();
			$history->notified = 1;
			$history->amount = $dbOrder->order_full_price;
			$history->data = ob_get_clean();
			$email->subject = JText::sprintf('PAYMENT_NOTIFICATION_FOR_ORDER', 'WechatPay', $data['result_code'], $dbOrder->order_number);
			$email->body = str_replace('<br/>',"\r\n",JText::sprintf('PAYMENT_NOTIFICATION_STATUS', 'WechatPay', $data['result_code'])).' '.JText::sprintf('ORDER_STATUS_CHANGED', $this->payment_params->verified_status)."\r\n\r\n".$order_text;
			$Orderclass = hikashop_get('class.order');
			$order = $Orderclass->get($order_id);
			if($order->order_status != $this->payment_params->verified_status) {
				$this->modifyOrder($order_id, $this->payment_params->verified_status, $history, $email);
			}

			return true;
		}
		else {  //if an error has occurred 支付错误

			$email = new stdClass();
			$email->subject = JText::sprintf('NOTIFICATION_REFUSED_FOR_THE_ORDER', 'WechatPay').'invalid response';
			$email->body = JText::sprintf("Hello,\r\n A WechatPay notification was refused because the response from the WechatPay server was invalid. Error code: ".$data['result_code'])."\r\n\r\n";
			$Orderclass = hikashop_get('class.order');
			$order = $Orderclass->get($order_id);
			if($order->order_status != $this->payment_params->invalid_status) {
				$this->modifyOrder($order_id, $this->payment_params->invalid_status, false, $email);
			}
			$app->enqueueMessage('Transaction Failed with the result code : '.$data['result_code']);
			$msg = "支付错误";
			return false;
		}
	}
}

Log::DEBUG("begin notify");
$notify = new PayNotifyCallBack();
$notify->Handle(false);
