<?php
/**
 * @package	HikaShop for Joomla!
 * @version	3.0.1
 * @author	hikashop.com
 * @copyright	(C) 2010-2017 HIKARI SOFTWARE. All rights reserved.
 * @license	GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php
class plgHikashoppaymentWechatpay extends hikashopPaymentPlugin
{
	var $accepted_currencies = array( 'CNY', 'HKD', 'USD', 'EUR', 'GBP', 'JPY', 'CAD', 'AUD', 'SGD', 'RUB', 'NZD', 'KRW', 'THB' );
	var $multiple = true;
	var $name = 'wechatpay';
	var $pluginConfig = array(
		'appid' => array('Appid', 'input'),
		'mchid' => array('Mchid', 'input'),
		'key' => array('Key', 'input'),
		'appsecret' => array('Appsecret', 'input'),
		'sslcert_path' => array('SSL cert path', 'input'),
		'sslkey_path' => array('SSL key path', 'input'),
		'trade_type' => array('Trade type', 'list', array(
			'JSAPI' => 'JSAPI',
			'NATIVE' => 'NATIVE'
		)),
		'sign_type' => array('Signature type', 'list', array(
			'MD5' => 'MD5',
			'HMAC-SHA256' => 'HMAC-SHA256'
		)),
		'sandbox' => array('Sandbox', 'boolean', '0'),
		'debug' => array('DEBUG', 'boolean', '0'),
		'notification' => array('ALLOW_NOTIFICATIONS_FROM_X', 'boolean', '1'),
		'pending_status' => array('PENDING_STATUS', 'orderstatus'),
		'invalid_status' => array('INVALID_STATUS', 'orderstatus'),
		'verified_status' => array('VERIFIED_STATUS', 'orderstatus')
	);

	function onAfterOrderConfirm(&$order,&$methods,$method_id) {
		parent::onAfterOrderConfirm($order, $methods, $method_id);  //强制初始化支付方式的属性
		
		define('WXPAY_APPID', trim($this->payment_params->appid));
		define('WXPAY_MCHID', trim($this->payment_params->mchid));
		define('WXPAY_KEY', trim($this->payment_params->key));
		define('WXPAY_APPSECRET', trim($this->payment_params->appsecret));
		define('WXPAY_NOTIFY_URL', HIKASHOP_LIVE.$this->name.'_'.$this->payment_params->appid.'.php');
		
		define('WXPAY_SSLCERT_PATH', trim($this->payment_params->sslcert_path));
		define('WXPAY_SSLKEY_PATH', trim($this->payment_params->sslkey_path));
		
		//ini_set('date.timezone','Asia/Shanghai');
		//error_reporting(E_ERROR);
		require_once __DIR__ . "/lib/wechatpay.api.php";
		require_once __DIR__ . "/wechatpay.jsapipay.php";
		require_once __DIR__ . "/wechatpay.nativepay.php";
		require_once __DIR__ . '/log.php';

		//初始化日志
		$logHandler= new CLogFileHandler('logs/'.date('Y-m-d').'.log');
		$log = Log::Init($logHandler, 15);

		//Notify回调通知链接中不能含有任何参数
		$notify_url = HIKASHOP_LIVE.$this->name.'_'.$this->payment_params->appid.'.php';
		$return_url = HIKASHOP_LIVE.'index.php?option=com_hikashop&ctrl=order&task=show&cid='.$order->order_id.$this->url_itemid;
		$cancel_url = HIKASHOP_LIVE.'index.php?option=com_hikashop&ctrl=order'.$this->url_itemid;
		//$notify_url = HIKASHOP_LIVE.'index.php?option=com_hikashop&ctrl=checkout&task=notify&notif_payment=' .$this->name. '&tmpl=component&lang=' .$this->locale . $this->url_itemid;
		//$return_url = HIKASHOP_LIVE.$this->name.'_'.$method_id.'_return.php';
	
		$out_trade_no = $order->order_id;
		$total_fee = round($order->order_full_price * 100);  //必须传递精确到整数值的货币最小单位，分
	
		//统一下单信息
		$input = new WxPayUnifiedOrder();
		$input->SetAppid($this->payment_params->appid);
		$input->SetMch_id($this->payment_params->mchid);
		$input->SetBody("Order");
		$input->SetAttach("OC");
		$input->SetOut_trade_no($out_trade_no);
		$input->SetFee_type($this->currency->currency_code);
		$input->SetTotal_fee($total_fee);
		$input->SetTime_start(date("YmdHis"));
		$input->SetTime_expire(date("YmdHis", time() + 600));
		$input->SetGoods_tag("LTHB");
		$input->SetNotify_url($notify_url);

		if (isset($_SERVER['HTTP_USER_AGENT']) && strpos($_SERVER['HTTP_USER_AGENT'], 'MicroMessenger') !== false ) {  //是微信移动端，自动适配为公众号支付模式
			$input->SetTrade_type("JSAPI");
			$tools = new JsApiPay();
			$openId = $tools->GetOpenid();
			$input->SetOpenid($openId);
			$order = WxPayApi::unifiedOrder($input);
			$this->jsApiParameters = $tools->GetJsApiParameters($order);
			
			//获取共享收货地址js函数参数
			$this->editAddress = $tools->GetEditAddressParameters();
			
			$this->return_url = $return_url;
			$this->cancel_url = $cancel_url;
			
			return $this->showPage('jsapi_end');
		}
		else{  //非微信移动端，自动适配为二维码支付模式
			$input->SetTrade_type("NATIVE");
			$input->SetProduct_id($out_trade_no);
			
			$notify = new NativePay();
			$result = $notify->GetPayUrl($input);
			$this->code_url = $result["code_url"];
			
			return $this->showPage('native_end');
		}
	}
	
	function onPaymentNotification(&$statuses) {
		
		define('WXPAY_APPID', trim($this->payment_params->appid));
		define('WXPAY_MCHID', trim($this->payment_params->mchid));
		define('WXPAY_KEY', trim($this->payment_params->key));
		define('WXPAY_APPSECRET', trim($this->payment_params->appsecret));
		define('WXPAY_NOTIFY_URL', HIKASHOP_LIVE.$this->name.'_'.$this->payment_params->appid.'.php');
		
		define('WXPAY_SSLCERT_PATH', trim($this->payment_params->sslcert_path));
		define('WXPAY_SSLKEY_PATH', trim($this->payment_params->sslkey_path));
		
		require_once __DIR__ . '/notify.php';
	}
	
	function getPaymentDefaultValues(&$element) {
		$element->payment_name='WechatPay';
		$element->payment_description='You can pay by credit card using this payment method.';
		$element->payment_images='VISA,MasterCard';

		$element->payment_params->appid='';
		$element->payment_params->mchid='';
		$element->payment_params->key='';
		$element->payment_params->appsecret='';
		$element->payment_params->sslcert_path='Leave blank if No refund, download it from pay.weixin.qq.com';
		$element->payment_params->sslkey_path='Leave blank if No refund, download it from pay.weixin.qq.com';
		$element->payment_params->trade_type='JSAPI';
		$element->payment_params->sign_type='MD5';
		$element->payment_params->sandbox=false;
		$element->payment_params->debug=false;
		$element->payment_params->notification=true;
		$element->payment_params->pending_status='created';
		$element->payment_params->invalid_status='cancelled';
		$element->payment_params->verified_status='confirmed';
	}

	function onPaymentConfigurationSave(&$element) {
		parent::onPaymentConfigurationSave($element);
		
		$secret_key = $element->payment_params->appid;
		
		if(empty($element->payment_id)) {
			$pluginClass = hikashop_get('class.payment');
			$status = $pluginClass->save($element);
			if(!$status)
				return true;
			$element->payment_id = $status;
		}

		jimport('joomla.filesystem.file');
		$lang = JFactory::getLanguage();
		$locale = strtolower(substr($lang->get('tag'), 0, 2));

		$opts = array(
			'option' => 'com_hikashop',
			'ctrl' => 'checkout',
			'task' => 'notify',
			'notif_payment' => $this->name,
			'tmpl' => 'component',
			'lang' => $locale
		);
		
		$content = '<?php' . "\r\n";
		foreach($opts as $k => $v) {
			$v = str_replace(array('\'','\\'), '', $v);
			$content .= '$_GET[\''.$k.'\']=\''.$v.'\';'."\r\n".
						'$_REQUEST[\''.$k.'\']=\''.$v.'\';'."\r\n";
		}
		$content .= 'include(\'index.php\');'."\r\n";
		JFile::write(JPATH_ROOT.DS.$this->name.'_'.$secret_key.'.php', $content);
	/*
		unset($opts['notif_payment']);
		unset($opts['tmpl']);
		unset($opts['lang']);
		//$opts['task'] = 'after_end';
		$opts['task'] = 'order';
		
		$content = '<?php' . "\r\n";
		foreach($opts as $k => $v) {
			$v = str_replace(array('\'','\\'), '', $v);
			$content .= '$_GET[\''.$k.'\']=\''.$v.'\';'."\r\n".
						'$_REQUEST[\''.$k.'\']=\''.$v.'\';'."\r\n";
		}
		$content .= 'include(\'index.php\');'."\r\n";
		JFile::write(JPATH_ROOT.DS.$this->name.'_'.$element->payment_id.'_return.php', $content);
	*/	
		return true;
	}
}
